unit Unit6;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Forms, Dialogs, Controls, StdCtrls, 
  Buttons;

type
  TForm6 = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    SrcLabel: TLabel;
    DstLabel: TLabel;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    Excluded: TListBox;
    Included: TListBox;
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExcAllBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
  end;

var
  Form6: TForm6;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm6.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  try
  Index := GetFirstSelection(Excluded);
  MoveSelected(Excluded, Included.Items);
  SetItem(Excluded, Index);
  except
  end;
end;

procedure TForm6.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  try
  Index := GetFirstSelection(Included);
  MoveSelected(Included, Excluded.Items);
  SetItem(Included, Index);
  except
  end;
end;

procedure TForm6.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to Excluded.Items.Count - 1 do
    Included.Items.AddObject(Excluded.Items[I],
      Excluded.Items.Objects[I]);
  Excluded.Items.Clear;
  SetItem(Excluded, 0);
end;

procedure TForm6.ExcAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to Included.Items.Count - 1 do
    Excluded.Items.AddObject(Included.Items[I], Included.Items.Objects[I]);
  Included.Items.Clear;
  SetItem(Included, 0);
end;

procedure TForm6.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;

function TForm6.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TForm6.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
end;

procedure TForm6.FormShow(Sender: TObject);
begin
Excluded.Clear;
Included.Items := Form1.ComboBox1.Items;
end;

procedure TForm6.CancelBtnClick(Sender: TObject);
begin
close;
end;

procedure TForm6.OKBtnClick(Sender: TObject);
begin
Form1.ComboBox1.Items := Included.Items;
close;
end;

end.
